VERSION 5.00
Begin VB.UserControl IconTray 
   ClientHeight    =   750
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   750
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   750
   ScaleWidth      =   750
   ToolboxBitmap   =   "uIconTray.ctx":0000
   Begin VB.PictureBox picTray 
      Height          =   540
      Left            =   105
      ScaleHeight     =   32
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   32
      TabIndex        =   0
      Top             =   105
      Width           =   540
   End
End
Attribute VB_Name = "IconTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Dclaration de la fonction API pour la gestion de l'icne
Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" _
                            (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
' Dclarations de constantes
Private Const NIM_ADD = &H0
Private Const NIM_DELETE = &H2
Private Const NIM_MODIFY = &H1

Private Const NIF_ICON = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_TIP = &H4

' Toutes les messages intercepts
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_MBUTTONDBLCLK = &H209
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_LBUTTONUP = &H202
Private Const WM_MBUTTONUP = &H208
Private Const WM_RBUTTONUP = &H205

Private Const WM_MOUSEMOVE = &H200

' Dclaration du type pour l'icne de la barre des tches
Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

' La structure courante
Private nidTray As NOTIFYICONDATA
Private blEstAffiche As Boolean
Private stToolTipText As String

Public Enum vbButton
    vbLeft = 0
    vbMiddle = 1
    vbRight = 2
End Enum

Event Click()
Event DblClick()
Event MouseUp(Button As vbButton)
Event MouseDown(Button As vbButton)

Private Sub picTray_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
' Rcupre les vnements souris.
Select Case X
    Case WM_LBUTTONDBLCLK, WM_MBUTTONDBLCLK, WM_RBUTTONDBLCLK
        RaiseEvent DblClick
    Case WM_LBUTTONUP
        RaiseEvent MouseUp(vbLeft)
        RaiseEvent Click
    Case WM_MBUTTONUP
        RaiseEvent MouseUp(vbMiddle)
        RaiseEvent Click
    Case WM_RBUTTONUP
        RaiseEvent MouseUp(vbRight)
        RaiseEvent Click
    Case WM_LBUTTONDOWN
        RaiseEvent MouseDown(vbLeft)
    Case WM_MBUTTONDOWN
        RaiseEvent MouseDown(vbMiddle)
    Case WM_RBUTTONDOWN
        RaiseEvent MouseDown(vbRight)
    Case Else
        ' Rien
End Select
End Sub
Public Function Show()
' Affiche l'icne dans la barre des tches
Dim lgRep As Long
nidTray.szTip = stToolTipText & vbNullChar
nidTray.uFlags = NIF_MESSAGE + NIF_ICON + NIF_TIP
nidTray.uID = 101
nidTray.cbSize = Len(nidTray)
' Dfinit le handle du contrle pour la fonction de rappel
nidTray.hwnd = picTray.hwnd
nidTray.uCallbackMessage = WM_MOUSEMOVE
nidTray.hIcon = picTray.Picture
lgRep = Shell_NotifyIcon(NIM_ADD, nidTray)
If lgRep Then blEstAffiche = True
End Function

Public Sub Hide()
' On enlve l'icne de la barre des tches
Dim lgRep As Long
nidTray.uID = 101
nidTray.cbSize = Len(nidTray)
nidTray.hwnd = picTray.hwnd
nidTray.uCallbackMessage = WM_MOUSEMOVE
lgRep = Shell_NotifyIcon(NIM_DELETE, nidTray)
If lgRep Then blEstAffiche = False
End Sub

Property Get ToolTipText() As String
' Retourne le ToolTipText courant
ToolTipText = stToolTipText
End Property

Property Let ToolTipText(stData As String)
Dim lgRep As Long
' Dfinition du ToolTipText
stToolTipText = Left$(stData, 63)
nidTray.szTip = stToolTipText & vbNullChar
' Mise  jour si l'icne est dj dans la barre des tches
If blEstAffiche Then
    ' Indique une mise  jour du ToolTipText
    nidTray.uFlags = NIF_TIP
    nidTray.uID = 101
    nidTray.hwnd = picTray.hwnd
    nidTray.cbSize = Len(nidTray)
    nidTray.uCallbackMessage = WM_MOUSEMOVE
    ' Mise en place de la modification
    lgRep = Shell_NotifyIcon(NIM_MODIFY, nidTray)
End If
End Property
Property Get EstAffiche() As Boolean
' Indique l'tat de l'affichage courant de l'icne
EstAffiche = blEstAffiche
End Property

Private Sub UserControl_Initialize()
' Initialisation des variables
blEstAffiche = False
stToolTipText = vbNullString
picTray.Top = 0
picTray.Left = 0
Call UserControl_Resize
End Sub

Private Sub UserControl_Resize()
' Redimensionnement du UserControl  la taille du PictureBox
UserControl.Width = picTray.Width
UserControl.Height = picTray.Height
End Sub

Private Sub UserControl_Terminate()
' Dchargement du contrle, on s'assure que l'icne n'est pas affich,
' sinon, on l'enlve.
If blEstAffiche Then Call Hide
End Sub
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Renvoie ou dfinit un graphisme  afficher dans un contrle."
Set Picture = picTray.Picture
End Property
Public Property Set Picture(ByVal New_Picture As Picture)
' Dfinition de l'icne
Dim lgRep As Long
Set picTray.Picture = New_Picture
nidTray.hIcon = picTray.Picture
' Mise  jour si l'icne est dj dans la barre des tches
If blEstAffiche Then
    ' Indique une mise  jour de l'icne
    nidTray.uFlags = NIF_ICON
    nidTray.uID = 101
    nidTray.hwnd = picTray.hwnd
    nidTray.cbSize = Len(nidTray)
    nidTray.uCallbackMessage = WM_MOUSEMOVE
    ' Mise en place de la modification
    lgRep = Shell_NotifyIcon(NIM_MODIFY, nidTray)
End If
PropertyChanged "Picture"
End Property
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
' Charger les valeurs des proprits  partir du stockage
Set Picture = PropBag.ReadProperty("Picture", Nothing)
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
' crire les valeurs des proprits dans le stockage
Call PropBag.WriteProperty("Picture", Picture, Nothing)
End Sub
